#include <qapplication.h>
#include <qstringlist.h>
#include <qcombobox.h>
#include <qstylefactory.h>

#include "firststartImpl.h"

/** The initial config dialog which is displayed
 *  at the first start of a fresh (= no ~/.tipografrc has been found)
 *  installation.
 */
firststartImpl::firststartImpl(QStringList slLanguageTxt,
			       QStringList slGUIStyleTxt,
			       QWidget* parent,
			       const char* name,
			       bool modal, WFlags fl)
  : dlgFirstStart(parent, name, modal, fl)
{
  cbLanguage->insertStringList(slLanguageTxt);
  cbGUIStyle->insertStringList(slGUIStyleTxt);
}

firststartImpl::~firststartImpl()
{
  
}

int firststartImpl::getLanguage()
{
  return(cbLanguage->currentItem());
}

int firststartImpl::getGUIStyle()
{
  return(cbGUIStyle->currentItem());
}

void firststartImpl::guiStyle()
{
  QApplication::setStyle(QStyleFactory::create(cbGUIStyle->currentText()));
}
