#ifndef TRANS_H
#define TRANS_H

#include <qstring.h>

/** This structure is passed from init() to the constructor
 *  of the main Tipograf dialog.
 */
struct tipoInit {
  bool bFirstStart;
  int  iTipoLanguageInit;
  int  iGUIStyleInit;
  QString sPathA2psInit;
  QString sPathGvInit;
};

/** This function is called from main() to initialize
 *  the program. This has to be done outside of the main
 *  dialog object tipografImpl because the translator has
 *  to be started before tipografImpl's constructor is called.
 */
tipoInit * init();

/** Figures out absolute path to config file.
 *  It checks the HOME env variable via getenv.
 *  In case getenv returns an error it kills the
 *  program since it does not make sense to run 
 *  user applications without HOME being set.
 *  @return $HOME/.tipografrc
 */
QString resolveConfigFileName();

#endif
