#ifndef TIPOGRAFIMPL_H
#define TIPOGRAFIMPL_H

#include <qstringlist.h>
// This is one of the reasons why Qt 3 is needed.
#include <qprocess.h>
#include <qstring.h>
#include <qtranslator.h>
#include <qapplication.h>

#include "tipograf.h"
#include "init.h"

// Defined in main.cc.
extern QApplication * appTipo;

/** Main dialog class.
 */
class tipografImpl : public dlgTipograf
{ 
  Q_OBJECT

public:
  // Implemented in tipografImplConstructor.cc.
  tipografImpl(tipoInit * tiInitVals,
	       QWidget* parent = 0, const char* name = 0,
	       bool modal = FALSE, WFlags fl = 0);
  ~tipografImpl();

public slots:
  // Main buttons at the bottom of the dialog.
  void ok();
  void preview();
  void readView();
  void readGen();
  void exit();
  void help();
  // Input / output tab.
  void input();
  void output();
  void outputTo();
  void printer();
  void selfDefinedStyle();
  void type();
  void readType();
  void simpleOptions();
  // Title tab.
  void selfDefinedHeaders();
  // Layout tab.
  void order();
  // Processing tab.
  int  commandLine();
  // See section private for orderedOptions().
  // Tipo tab.
  void guiStyle();
  void tipoLanguage();
  void pathA2ps();
  void pathGv();
  void configFile();
  void loadConfig(); // implemented in tipografImplConfig.cc
  void saveConfig(); // implemented in tipografImplConfig.cc
  void loadTipo();   // implemented in tipografImplConfig.cc
  void saveTipo();   // implemented in tipografImplConfig.cc
  void about();

private:
  // StdStyles
  QStringList slStdStyleOpt;
  QStringList slStdStyleTxt;

  // OutputTo
  QStringList slOutputToTxt;
  QString sOutputToFileOpt;

  // Printer
  QStringList slPrinterOpt;
  QStringList slPrinterTxt;
  QStringList slPrinterDesc;

  // Type
  QString sTypeOpt;

  // SimpleOptionLineNumbers
  QString sSimpleOptionLineNumbersOpt;

  // SimpleOptionColored
  QString sSimpleOptionColoredOpt;

  // Format
  QStringList slFormatOpt;
  QStringList slFormatTxt;

  // Orientation
  QStringList slOrientationOpt;
  QStringList slOrientationTxt;

  // Direction
  QStringList slDirectionOpt;
  QStringList slDirectionTxt;

  // Rows
  QString sRowsOpt;

  // Columns
  QString sColumnsOpt;

  // Margin
  QString sMarginOpt;

  // Duplex
  QStringList slDuplexOpt;
  QStringList slDuplexTxt;

  // VirtualBorder
  QString sVirtualBorderOpt;

  // PSTitle
  QString sPSTitleOpt;

  // Headings
  QString sHeadLeftOpt;
  QString sHeadCenterOpt;
  QString sHeadRightOpt;
  QString sFootLeftOpt;
  QString sFootCenterOpt;
  QString sFootRightOpt;
  QString sWatermarkOpt;

  // Order
  QStringList slOrderTxt;
  int iOrder;

  // FontSize
  QString sFontSizeOpt;

  // RowsPerPage
  QString sRowsPerPageOpt;

  // CharsPerRow
  QString sCharsPerRowOpt;

  // ColorLevel
  QStringList slColorLevelOpt;
  QStringList slColorLevelTxt;

  // Comments
  QStringList slCommentsOpt;
  QStringList slCommentsTxt;

  // Language
  QStringList slLanguageOpt;
  QStringList slLanguageTxt;

  // Unprintables
  QStringList slUnprintablesTxt;
  QStringList slUnprintablesOpt;

  // PostScript
  QStringList slPostScriptTxt;
  QStringList slPostScriptOpt;

  // TabSize
  QString sTabSizeOpt;

  // LineNumbers
  QString sLineNumbersOpt;

  // TOC
  QString sTOCOpt;

  // Truncate
  QString sTruncateOpt;

  // Encoding
  QStringList slEncodingTxt;
  QStringList slEncodingOpt;

  // Delegate
  QString sDelegateYesOpt;
  QString sDelegateNoOpt;

  // Prefeed
  QString sPrefeedOpt;

  // Copies
  QString sCopiesOpt;

  // Processes
  QProcess * procType;
  QProcess * procGen;
  QProcess * procView;
  QString sTmpFileName;

  // CommandLine
  QStringList slCommandLine;

  // Tipo language
  QStringList slTipoLanguageTxt;

  // GUI style
  QStringList slGUIStyleTxt;
  QStringList slGUIStyleOpt;

  // StartUp
  bool finishedStartUp;

  // Internal functions (processing tab).
  QString orderedOptions();
};

#endif // TIPOGRAFIMPL_H
